
#include "const.h"
#include "types.h"
#include "globals.h"
#include "macros.h"
#include "proto.h"
#include "matrices.h"



/*********************************************************************************
* DEBUG PRINTBITBOARD: Used to display a bitboard in 8 lines. For debugging      *
*   purposes only.                                                               *
*********************************************************************************/
void dPrintBitboard(BITBOARD b) {
	int i;
	
	for (i=0;i<64;i++) {
		Dualprintf((b&mask64[i]) ? "1" : "x");
		if (!((i+1)&7))
			Dualprintf("\n");
	}
}


/*********************************************************************************
* DEBUG PRINTENEMYATTACKS: Displays a virtual bitboard with attacked squares.    *
*********************************************************************************/
void dPrintEnemyAttacks(GAME *g) {
	int i;
	
	for (i=0;i<64;i++) {
		Dualprintf(AttackedByEnemy(g,i) ? "1" : "x");
		if (!((i+1)&7))
			Dualprintf("\n");
	}
}


/*********************************************************************************
* DEBUG PRINTCHARBITS: Displays all bits of an 8bit variable in one single line. *
*********************************************************************************/
void dPrintCharbits(char c) {
	int i;
	
	for (i=0;i<8;i++)
		Dualprintf((c&mask8[i]) ? "1" : "x");
	Dualprintf("\n");
}