/*********************************************************************************
* GLOBAL VARIABLES                                                               *
*********************************************************************************/

#pragma once

static const char line_char[9]="abcdefgh";
static const char rank_char[9]="12345678";

static const BITBOARD bitboard_1 = 1;

FILE *fp;

static long clock_offset=0;

static int program_state=1;
static int exploration_state=0;
static int chess_interface=PHRI;
static int input_query_phase=0;

/* masks */
static BITBOARD mask64[64];
static BITBOARD imask64[64];
static BITBOARD m_line[8];
static BITBOARD m_rank[8];
static BITBOARD m_ranks_ahead[2][8];
static unsigned long mask32[32];
static unsigned long imask32[32];
static unsigned char mask8[8];
static unsigned char imask8[8];

/* structs */

/* attack boards */
static BITBOARD rank_attacks[64][256];
static BITBOARD line_attacks[64][256];
static BITBOARD diagLR_attacks[64][256];
static BITBOARD diagRL_attacks[64][256];
static BITBOARD knight_attacks[64];
static BITBOARD pawn_attacks[64][2];
static BITBOARD pawn_nonattacks_singlestep[64][2];
static BITBOARD king_attacks[64];

static BITBOARD castlingfields_king_side[2];
static BITBOARD castlingfields_queen_side[2];
static BITBOARD fianchetto_king_side[2];
static BITBOARD fianchetto_queen_side[2];
static BITBOARD lightfigure_startpositions[2];

static BITBOARD zobrist_figure[2][7][64];
static BITBOARD zobrist_castling_disallowed[2][4];
static BITBOARD zobrist_enpassant[64];
static BITBOARD zobrist_whitetomove;
	
static BITBOARD pawnlines;
static BITBOARD pawnline_tails_a;
static BITBOARD pawnline_tails_h;

static BITBOARD bishop_cage_c[2];
static BITBOARD bishop_cage_f[2];
	
static int dangerousness_centipawns[100];

#ifdef BCC32
	HANDLE win32_inputhandle;
	DWORD win32_consolemode;
	char win32_pipe;
#endif

static char cmd_queue[BUFSIZE];
static HASHENTRY *transposition_table;
static int tt_entries;
static int hash_megabytes=32;

static int limit_type=ITERATE_NONE;
static int limit_value=0;

static int nowhere; /* for useless function returns */

static int phri_level=5;