
#pragma once

/*********************************************************************************
* PROTOTYPES                                                                     *
*********************************************************************************/
/* Some compilers will be happy, if there are some function
 * prototypes, so I'm doing 'em this favour. */

int AttackedByEnemy(GAME *, int);
int CntBits (BITBOARD);
int DetectDraw(GAME *, int *, int);
int DetectEndOfGame(GAME *);
void DetectInterruption(GAME *);
int DeterminePhase(GAME *);
void DoMove(GAME *, MOVE, SITBACKUP *);
void dPrintBitboard(BITBOARD);
void dPrintCharbits(char);
void dPrintEnemyAttacks(GAME *);
void Dualprintf(char *, ...);
void Error(char *, int, char *, ...);
int Evaluate(GAME*, int);
int Explore (GAME *, int, int, int);
int ExploreRoot (GAME *, int, int, int);
int GenerateAP(GAME *, MOVE *, int);
int GenerateN(GAME *, MOVE *, int);
void Init(GAME*);
void InitOriginalPosition(GAME *);
void InitTranspositionTable(int);
void InitZobristKeys(void);
int Iterate(GAME *g, char *s);
int MSB (BITBOARD);
int LSB (BITBOARD);
char* ParseFEN (GAME *, char *);
int ParseInterfaceChange (char *buffer);
MOVE ParseMove (GAME *g, char *buffer);
BITBOARD Random64(void);
void PHRIDangerousnessRow(char *, int, int, int);
void PHRIDisplayBoard(GAME*);
int PHRIParseCmd(GAME *, char *);
void PHRIPrintMove(MOVE);
void PHRIStaticEvaluationHeader(char *);
void PHRIStaticEvaluationRow(char *, int, int, int);
int QueryWin32Input(void);
int Quiesce (GAME *, int, int);
BITBOARD Random64(void);
int ReadLine(char *);
int RefreshBitboards(GAME*);
int TTFetchEntry(GAME *, int *, int, int, int, MOVE *);
void TTStoreEntry(GAME *, int, int, int, MOVE);
void UCIIdentify(void);
int UCIParseCmd(GAME *, char *);
void UnDoMove(GAME *, SITBACKUP *);

/* the following functions are not fully declared at some systems (e.g. CodeWarrior?)*/
int abs (int);

